variables:
  PACKAGE_VERSION: $(cat package.json | grep version | head -1 | awk -F= "{ print $2 }" | sed 's/[version:,\",]//g' | tr -d '[[:space:]]')
  SSH_USER: kkl
  SSH_PATH: /home/kkl/www/spiel

workflow:
  rules:
    - if: $CI_COMMIT_TAG

cache:
  paths:
    - node_modules/

stages:
  - build
  - zip
  - publish


build:
  stage: build
  image: node:14.7.0-alpine
  script:
    - echo "## build project version > $PACKAGE_VERSION"
    - npm ci
    - |
      npm run build -- --env \
      AUTH0_DOMAIN=$AUTH0_DOMAIN \
      AUTH0_CLIENT_ID=$AUTH0_CLIENT_ID \
      AUTH0_AUDIENCE=$AUTH0_AUDIENCE \
      GOOGLE_API_KEY=$GOOGLE_API_KEY
    - cd dist/
    - ls -l
  artifacts:
    paths:
      - dist/
    expire_in: 20 minutes


zip:
  stage: zip
  image: alpine
  dependencies:
    - "build"
  before_script:
    - apk add zip
  script:
    - zip -r scoresheet-client.zip dist/
  artifacts:
    name: "$CI_PROJECT_NAME-$CI_COMMIT_TAG"
    paths:
      - scoresheet-client.zip
    expire_in: 1 week


# example: https://medium.com/devops-with-valentine/deploy-over-ssh-from-gitlab-ci-pipeline-6a0d7b87e4a
publish:
  stage: publish
  image: alpine
  dependencies:
    - "zip"
  before_script:
    - apk add unzip
    - apk add openssh-client
    - eval $(ssh-agent -s)
    - echo "$SSH_PRIVATE_KEY" | tr -d '\r' | ssh-add -
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
  script:
    - scp -o StrictHostKeyChecking=no scoresheet-client.zip "$SSH_USER@$SSH_HOST:$SSH_PATH"
    - ssh -o StrictHostKeyChecking=no "$SSH_USER@$SSH_HOST" "cd $SSH_PATH; unzip -o scoresheet-client.zip"
